unit Unit10;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VCL.TMSFNCTypes, VCL.TMSFNCUtils,
  VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, VCL.TMSFNCCustomControl,
  VCL.TMSFNCCustomSelector, VCL.TMSFNCBitmapSelector, System.Generics.Collections, System.IOUtils, System.Math, StrUtils;

type
  TDocumentClass = class(TPersistent)
  private
    FFilename: string;
    FDescription: string;
  published
    property Filename: string read FFilename write FFilename;
    property Description: string read FDescription write FDescription;
  end;
  TForm10 = class(TForm)
    bsDocImages: TTMSFNCBitmapSelector;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure PopulateDocPicGallery;
  public
    { Public declarations }
  end;

var
  Form10: TForm10;

implementation

{$R *.dfm}

procedure TForm10.FormShow(Sender: TObject);
begin
  PopulateDocPicGallery
end;

procedure TForm10.PopulateDocPicGallery;
var
  img: TList<TDocumentClass>;
  i: Integer;
  tmpFname: string;
  imgFile: TDocumentClass;
  ctrlImgItem: TTMSFNCBitmapSelectorItem;
  localFilename: string;
  localPathFilename: string;
  paths: TArray<string>;
begin
  SetLength(paths, 2);
  paths[0] := TPath.Combine(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))), 'a.png');
  paths[1] := TPath.Combine(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))), 'b.png');

  img := TList<TDocumentClass>.Create;
  try
    for i := 0 to 1 do
    begin
      tmpFname := paths[i];
      if (TFile.Exists(tmpFname)) and (MatchText(TPath.GetExtension(tmpFname), ['.jpg', '.jpeg', '.png', '.bmp'])) then
      begin
        imgFile := TDocumentClass.Create;
        imgFile.Filename := tmpFname;
        imgFile.Description := string.format('%d', [i]);
        img.Add(imgFile);
      end;
    end;
    bsDocImages.BeginUpdate;
    bsDocImages.Items.Clear;
    bsDocImages.Columns := 4;
    bsDocImages.Rows := Ceil(img.Count / 4);
    //bsDocImages.Height := bsDocImages.Rows * (screenWidth / 4);
    for i := 0 to img.Count - 1 do
    begin
      ctrlImgItem := bsDocImages.Items.Add;
      localFilename := TPath.GetFilename(img[i].FILENAME);
      localPathFilename := img[i].FILENAME;
      ctrlImgItem.Bitmap.LoadFromFile(localPathFilename);
      ctrlImgItem.BitmapName := string.format('%s', [localFilename]);
      if (not string.IsNullOrEmpty(img[i].Description)) then
      begin
        ctrlImgItem.VerticalTextAlign := TTMSFNCGraphicsTextAlign.gtaTrailing;
        ctrlImgItem.Text := img[i].Description;
      end;
    end;
    //   bsDocImages.Appearance.HorizontalSpacing := 40;
    //   bsDocImages.Appearance.VerticalSpacing := 40;
    bsDocImages.EndUpdate;
    bsDocImages.Repaint;
  finally
    img.Free;
  end;
end;

end.
